package Gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import fahrzeug.*;
import kunde.*;

/**
 * Schnittstelle zur Auswahl von Kategorie und Klasse.
 * Sie ist die erste Schnitstelle beim Erzeugen von Angeboten
 * 
 * @author Nathalie
 */
 
public class AngebotStarter extends javax.swing.JFrame
{
	public AngebotStarter()
	{   
		//{{INIT_CONTROLS
		setTitle("Angebot");
		setDefaultCloseOperation(javax.swing.JFrame.DO_NOTHING_ON_CLOSE);
		getContentPane().setLayout(new BorderLayout(0,0));
		getContentPane().setBackground(new java.awt.Color(226,228,241));
		setSize(488,309);
		setVisible(false);
		mainGeneralPanel.setLayout(null);
		getContentPane().add(BorderLayout.CENTER, mainGeneralPanel);
		mainGeneralPanel.setBackground(new java.awt.Color(226,228,241));
		mainGeneralPanel.setBounds(0,0,488,309);
		javax.swing.JLabel titleLabel = new JLabel("Fahrzeug");
		titleLabel.setBounds(36,10,100,25);
		mainGeneralPanel.add(titleLabel);		
		KategoriePanel.setLayout(null);
		mainGeneralPanel.add(KategoriePanel);
		KategoriePanel.setBackground(new java.awt.Color(226,228,241));
		KategoriePanel.setBounds(36,24,367,98);
		KategorieCombo.setNextFocusableComponent(KlasseKombo);
		for(int i=0; i < Kategorien.length; i++)
		{
		 KategorieCombo.addItem(Kategorien[i]);    
		}
		KategoriePanel.add(KategorieCombo);
		KategorieCombo.setBounds(48,36,240,27);
		KategorieLabel.setText("Kategorie");
		KategoriePanel.add(KategorieLabel);
		KategorieLabel.setBounds(48,12,240,27);
		FahrzeugklassePanel.setLayout(null);
		mainGeneralPanel.add(FahrzeugklassePanel);
		FahrzeugklassePanel.setBackground(new java.awt.Color(226,228,241));
		FahrzeugklassePanel.setBounds(36,132,367,98);
		KlasseKombo.setNextFocusableComponent(KategorieCombo);
		FahrzeugklassePanel.add(KlasseKombo);
		KlasseKombo.setBounds(48,48,240,27);
		for(int k=0; k< PKWKlassen.length ; k++)
		{
		 KlasseKombo.addItem(PKWKlassen[k]);    
		}
		KlasseLabel.setText("Klasse");
		FahrzeugklassePanel.add(KlasseLabel);
		KlasseLabel.setBounds(48,24,240,27);
		NavigatinPanel.setLayout(null);
		mainGeneralPanel.add(NavigatinPanel);
		NavigatinPanel.setBackground(new java.awt.Color(226,228,241));
		NavigatinPanel.setBounds(12,252,457,43);
		NextButton.setText(">");
		NextButton.setActionCommand(">");
		NavigatinPanel.add(NextButton);
		NextButton.setBackground(java.awt.Color.lightGray);
		NextButton.setForeground(java.awt.Color.black);
		NextButton.setBounds(408,12,41,25);
		DetailAngebotMaskeButton.setLabel("Angebot Formular");
		NavigatinPanel.add(DetailAngebotMaskeButton);
		DetailAngebotMaskeButton.setBackground(java.awt.Color.lightGray);
		DetailAngebotMaskeButton.setBounds(288,12,112,25);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		NextButton.addActionListener(lSymAction);
		SymItem lSymItem = new SymItem();
		KlasseKombo.addItemListener(lSymItem);
		KategorieCombo.addItemListener(lSymItem);
		DetailAngebotMaskeButton.addActionListener(lSymAction);
		//}}
	
	  	}

   public AngebotStarter(Kundenanfrage zuKunden)
	{
	 this();
	 zurueckAnKunde = zuKunden;
	}
	
	
	public AngebotStarter(String sTitle)
	{
		this();
		setTitle(sTitle);
	}
	
	
	static public void main(String args[])
	{
		try {
		   

			(new AngebotStarter()).setVisible(true);
		} 
		catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
	}

   
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();
		
		super.addNotify();
		
		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;
		
		// Adjust size of frame according to the insets and menu bar
		javax.swing.JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
		    menuBarHeight = menuBar.getPreferredSize().height;
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JPanel mainGeneralPanel = new javax.swing.JPanel();
	javax.swing.JPanel KategoriePanel = new javax.swing.JPanel();
	javax.swing.JComboBox KategorieCombo = new javax.swing.JComboBox();
	javax.swing.JLabel KategorieLabel = new javax.swing.JLabel();
	javax.swing.JPanel FahrzeugklassePanel = new javax.swing.JPanel();
	javax.swing.JComboBox KlasseKombo = new javax.swing.JComboBox();
	javax.swing.JLabel KlasseLabel = new javax.swing.JLabel();
	javax.swing.JPanel NavigatinPanel = new javax.swing.JPanel();
	javax.swing.JButton NextButton = new javax.swing.JButton();
	java.awt.Button DetailAngebotMaskeButton = new java.awt.Button();
	//}}

	
	
	//{{additionale properties
	Kundenanfrage zurueckAnKunde;
	String[] PKWKlassen = {"Kompaktwagen","Mittelklasse","Oberklasse","Van"};
	String[] LKWKlassen = {">2.8","<2.8"};
	String[] PickUpKlassen = {"-"};
	String[] Kategorien = {"PKW","LKW","PickUp"};
	//}}

	void exitApplication()
	{
		try {
	    	// Beep
	    	Toolkit.getDefaultToolkit().beep();
	    	// Show a confirmation dialog
	    	int reply = JOptionPane.showConfirmDialog(this, 
	    	                                          "Wollen Sie beenden?", 
	    	                                          "Angebot beenden" , 
	    	                                          JOptionPane.YES_NO_OPTION, 
	    	                                          JOptionPane.QUESTION_MESSAGE);
			// If the confirmation was affirmative, handle exiting.
			if (reply == JOptionPane.YES_OPTION)
			{
		    	this.setVisible(false);    // hide the Frame
		    	this.dispose();            // free the system resources
		    	System.exit(0);            // close the application
			}
		} catch (Exception e) {
		}
	}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == AngebotStarter.this)
				AngebotStarter_windowClosing(event);
		}
	}

	void AngebotStarter_windowClosing(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
			 
		AngebotStarter_windowClosing_Interaction1(event);
	}

	void AngebotStarter_windowClosing_Interaction1(java.awt.event.WindowEvent event) {
		try {
			this.setVisible(false);
			dispose();
		} catch (Exception e) {
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == NextButton)
				NextButton_actionPerformed(event);
			else if (object == DetailAngebotMaskeButton)
				DetailAngebotMaskeButton_ActionPerformed(event);
			
			
		}
	}

	void NextButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		NextButton_actionPerformed_Interaction1(event);
	}

	void NextButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		zurueckAnKunde.fahrzeugKategorieKlasseEingabe((String)KategorieCombo.getSelectedItem(), (String) KlasseKombo.getSelectedItem(),false);
	}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == KlasseKombo)
				KlasseKombo_itemStateChanged(event);
			else if (object == KategorieCombo)
				KategorieCombo_itemStateChanged(event);
		}
	}

	void KlasseKombo_itemStateChanged(java.awt.event.ItemEvent event)
	{
		// to do: code goes here.
			 
		KlasseKombo_itemStateChanged_Interaction1(event);
	}

	void KlasseKombo_itemStateChanged_Interaction1(java.awt.event.ItemEvent event)
	{
		try {
			//Speichern der gewhlten Klasse 
		
		} catch (java.lang.Exception e) {
		}
	}

	void KategorieCombo_itemStateChanged(java.awt.event.ItemEvent event)
	{
		// to do: code goes here.
			 
		KategorieCombo_itemStateChanged_Interaction1(event);
	}

	void KategorieCombo_itemStateChanged_Interaction1(java.awt.event.ItemEvent event)
	{
	 //Update der Liste in der Klassenkombo und speichern der gewhlten Kategorie
	 if(((String)KategorieCombo.getSelectedItem()).equals("PKW"))
	  {
	   KlasseKombo.removeAllItems();
	   for(int k=0; k< PKWKlassen.length ; k++)
		{
		 KlasseKombo.addItem(PKWKlassen[k]);    
		}
	  }
	 else
	   if(((String)KategorieCombo.getSelectedItem()).equals("LKW"))
	    {
	      KlasseKombo.removeAllItems();
	      for(int l=0; l< LKWKlassen.length ; l++)
		  {
		   KlasseKombo.addItem(LKWKlassen[l]);    
		   }  
	     }
	    else
	      {//PickUp
	        KlasseKombo.removeAllItems();
	        KlasseKombo.addItem(PickUpKlassen[0]);
	       }
	  KlasseKombo.invalidate();
	}

	void DetailAngebotMaskeButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		DetailAngebotMaskeButton_ActionPerformed_Interaction1(event);
	}

	void DetailAngebotMaskeButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		// AngebotFormular Create and show the AngebotFormular
		zurueckAnKunde.fahrzeugKategorieKlasseEingabe((String)KategorieCombo.getSelectedItem(), (String) KlasseKombo.getSelectedItem(),true);
	    setVisible(false);
	    dispose();
	}
}
