package Gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import fahrzeug.*;
import kunde.*;
import Starter;
import dvtautoio.*;

/**
 * Diese Benutzerschnittstelle wird zur Rckgabe der Fahrzeuge verwendet.
 * Dabei wird ein Eingabemaske zur Eingabe der Schaden geffnet, die Schaden werden eingegeben
 * und Tankfllstand wird festgestellt. Diese werte werden dann im bei dem entsprechenden Fahrzeug
 * in der Liste eingetragen und die Liste wird aktuallisiert.
 * @author Shahriar
 * @author Nathalie
 */
public class FahrzeugAbgabeGUI extends javax.swing.JFrame
{
      public static Fahrzeug tmpFahrzeug;
      DVTAutoIO ioStream;
      FahrzeugBestand fzlBis28Liste;
      FahrzeugBestand fzlKompaktListe;
      FahrzeugBestand fzlMittelListe;
      FahrzeugBestand fzlOberListe;
      FahrzeugBestand fzlPickUpListe;
      FahrzeugBestand fzlUber28Liste;
      FahrzeugBestand fzlVanListe;


 public FahrzeugAbgabeGUI()
 {
      ioStream = new DVTAutoIO();
      fzlBis28Liste   =  (FahrzeugBestand)ioStream.datenBloeckeEinlesen(fzlBis28Liste,"bis2_8Tonnen");
      fzlKompaktListe =  (FahrzeugBestand)ioStream.datenBloeckeEinlesen(fzlKompaktListe,"KompaktKlasse");
      fzlMittelListe  =  (FahrzeugBestand)ioStream.datenBloeckeEinlesen(fzlMittelListe,"MittelKlasse");
      fzlOberListe    =  (FahrzeugBestand)ioStream.datenBloeckeEinlesen(fzlOberListe,"OberKlasse");
      fzlPickUpListe  =  (FahrzeugBestand)ioStream.datenBloeckeEinlesen(fzlPickUpListe,"PickUp");
      fzlUber28Liste  =  (FahrzeugBestand)ioStream.datenBloeckeEinlesen(fzlUber28Liste,"Ueber2_8Tonnen");
      fzlVanListe     =  (FahrzeugBestand)ioStream.datenBloeckeEinlesen(fzlVanListe,"Van");
      tmpFahrzeug = null ;
		getContentPane().setLayout(null);
		getContentPane().setBackground(java.awt.Color.white);
		setSize(500,395);
		setVisible(false);
		AbgabePanel.setLayout(null);
		getContentPane().add(AbgabePanel);
		AbgabePanel.setBackground(new java.awt.Color(226,228,241));
		AbgabePanel.setBounds(12,12,468,300);
		FahrzeugnummerLabel.setText("Fahrzeugnummer");
		AbgabePanel.add(FahrzeugnummerLabel);
		FahrzeugnummerLabel.setBounds(24,24,120,24);
		KmstandLabel.setText("Kilometerstand");
		AbgabePanel.add(KmstandLabel);
		KmstandLabel.setBounds(24,72,120,24);
		TankstandLabel.setText("Fllstand des Tanks");
		AbgabePanel.add(TankstandLabel);
		TankstandLabel.setBackground(new java.awt.Color(204,204,204));
		TankstandLabel.setBounds(24,120,156,24);
		AbgabePanel.add(TankfuellstandCombo);
		TankfuellstandCombo.setBounds(204,120,156,22);
		AbgabePanel.add(FahrzeugnummerTExtField);
		FahrzeugnummerTExtField.setBounds(204,24,185,28);
		AbgabePanel.add(KmstandTextField);
		KmstandTextField.setBounds(204,72,182,29);
		FahrzeugCheckButton.setText("ok");
		AbgabePanel.add(FahrzeugCheckButton);
		FahrzeugCheckButton.setBounds(408,24,52,27);
		NavPanel.setLayout(null);
		getContentPane().add(NavPanel);
		NavPanel.setBackground(new java.awt.Color(226,228,241));
		NavPanel.setBounds(0,325,496,50);
		WeiterButton.setText(">");
      WeiterButton.setEnabled(false);
		NavPanel.add(WeiterButton);
		WeiterButton.setBounds(396,12,73,25);
		{
			String[] tempString = new String[5];
			tempString[0] = "0";
			tempString[1] = "1/4";
			tempString[2] = "2/4";
			tempString[3] = "3/4";
			tempString[4] = "1";
		for(int i=0; i < 5; i++)
		   TankfuellstandCombo.addItem(tempString[i]);
		}

		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		WeiterButton.addActionListener(lSymAction);
		FahrzeugCheckButton.addActionListener(lSymAction);
		//}}
	}
	//{{DECLARE_CONTROLS
   javax.swing.JPanel AbgabePanel = new javax.swing.JPanel();
	javax.swing.JLabel FahrzeugnummerLabel = new javax.swing.JLabel();
	javax.swing.JLabel KmstandLabel = new javax.swing.JLabel();
	javax.swing.JLabel TankstandLabel = new javax.swing.JLabel();
	javax.swing.JComboBox TankfuellstandCombo = new javax.swing.JComboBox();
	javax.swing.JTextField FahrzeugnummerTExtField = new javax.swing.JTextField();
	javax.swing.JTextField KmstandTextField = new javax.swing.JTextField();
	javax.swing.JButton FahrzeugCheckButton = new javax.swing.JButton();
	javax.swing.JPanel NavPanel = new javax.swing.JPanel();
	javax.swing.JButton WeiterButton = new javax.swing.JButton();
	//}}
	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == WeiterButton)
				WeiterButton_actionPerformed(event);
			else if (object == FahrzeugCheckButton)
				FahrzeugCheckButton_actionPerformed(event);
		}
	}

	void WeiterButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		WeiterButton_actionPerformed_Interaction1(event);
	}

	void WeiterButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
            tmpFahrzeug.setzeVerfuegbar(true);
            tmpFahrzeug.setzeKilometerstand((new Integer(KmstandTextField.getText())).intValue());
            String sFloatWert = new String(TankfuellstandCombo.getSelectedItem().toString());
            if (0 == sFloatWert.compareToIgnoreCase("0")){
               tmpFahrzeug.setzeTank((float) 0);
            }else if (0 == sFloatWert.compareToIgnoreCase("1/4")){
               tmpFahrzeug.setzeTank((float) 1/4);
            }else if (0 == sFloatWert.compareToIgnoreCase("2/4")){
               tmpFahrzeug.setzeTank((float) 1/2);
            }else if (0 == sFloatWert.compareToIgnoreCase("3/4")){
               tmpFahrzeug.setzeTank((float) 3/4);
            }else if (0 == sFloatWert.compareToIgnoreCase("1")){
               tmpFahrzeug.setzeTank((float) 1);
            }

            ioStream.datenBloeckeAusschreiben(fzlBis28Liste,"bis2_8Tonnen");
            ioStream.datenBloeckeAusschreiben(fzlKompaktListe,"KompaktKlasse");
            ioStream.datenBloeckeAusschreiben(fzlMittelListe,"MittelKlasse");
            ioStream.datenBloeckeAusschreiben(fzlOberListe,"OberKlasse");
            ioStream.datenBloeckeAusschreiben(fzlPickUpListe,"PickUp");
            ioStream.datenBloeckeAusschreiben(fzlUber28Liste,"Ueber2_8Tonnen");
            ioStream.datenBloeckeAusschreiben(fzlVanListe,"Van");
            this.setVisible(false);
            this.dispose();

	}

	void FahrzeugCheckButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		FahrzeugCheckButton_actionPerformed_Interaction1(event);
	}

	void FahrzeugCheckButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
      int tmpFahrzeugNummer;

      tmpFahrzeugNummer =  (new Integer (this.FahrzeugnummerTExtField.getText()).intValue());

      tmpFahrzeug = fzlBis28Liste.FahrzeugSuchen(tmpFahrzeugNummer);
      if (tmpFahrzeug == null)tmpFahrzeug = fzlKompaktListe.FahrzeugSuchen(tmpFahrzeugNummer);
      if (tmpFahrzeug == null)tmpFahrzeug = fzlMittelListe.FahrzeugSuchen(tmpFahrzeugNummer);
      if (tmpFahrzeug == null)tmpFahrzeug = fzlOberListe.FahrzeugSuchen(tmpFahrzeugNummer);
      if (tmpFahrzeug == null)tmpFahrzeug = fzlPickUpListe.FahrzeugSuchen(tmpFahrzeugNummer);
      if (tmpFahrzeug == null)tmpFahrzeug = fzlUber28Liste.FahrzeugSuchen(tmpFahrzeugNummer);
      if (tmpFahrzeug == null)tmpFahrzeug = fzlVanListe.FahrzeugSuchen(tmpFahrzeugNummer);
      if (tmpFahrzeug == null){
        FahrZeugNummerFalschDialog tmpAbout = new FahrZeugNummerFalschDialog();
        tmpAbout.setVisible(true);
      }
      if (tmpFahrzeug != null)
       {
        if(!tmpFahrzeug.istVerfuegbar())
           WeiterButton.setEnabled(true);
        else
          (new GeneralDialog(this,"Fahrzeug wurde schon zurckgegeben")).setVisible(true);
       }
   }

  //********************MAIN******************************
  static public void main(String[] args)
	{
		try {
		    (new FahrzeugAbgabeGUI()).setVisible(true);
		}
		catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
	}
	//*********************************************

}
