//Titel:      DVTAuto
//Version:    
//Copyright:  Copyright (c) 2000
//Autor:     Nathalie Poerwantoro, Shahriar Fakher
//Organisation:    Lerhrgebiet Datenverarbeitungstechnik FernUni-Hagen

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import kunde.*;
import fahrzeug.*;
import Gui.*;
import dvtautoio.*;

/**
 * Dies ist das Haupfenster zur Steuerung des Programmes 
 */
public class StarterFrame extends JFrame {
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  BorderLayout borderLayout1 = new BorderLayout();
  JMenu menuFileNeu = new JMenu();
  JMenuItem neueFirmenKunde = new JMenuItem();
  JMenuItem neueReservierung = new JMenuItem();
  JMenu menuFahrzeug = new JMenu();
  JMenuItem fahrzeugVermieten = new JMenuItem();
  JMenuItem fahrzeugZuruecknehmen = new JMenuItem();
  JMenu menuAbrechnung = new JMenu();
  JMenuItem abrechnungPrivatKunde = new JMenuItem();
  JMenuItem abrechnungFirmenKunde = new JMenuItem();
  JLabel HintergrundBild = new JLabel(new ImageIcon("images/dvtautologo.gif"));  

  //Frame konstruieren
  public StarterFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Initialisierung der Komponente
  private void jbInit() throws Exception  {
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(300, 120));
    this.setTitle("DVTAuto");
    menuFile.setText("Datei");
    menuFileExit.setText("Beenden");
    menuFileExit.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    menuFileNeu.setText("neu...");
    neueFirmenKunde.setText("Firmenkunde");
    neueFirmenKunde.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        neueFirmenKunde_actionPerformed(e);
      }
    });
    neueReservierung.setText("Angebot/ Reservierung");
    neueReservierung.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        neueReservierung_actionPerformed(e);
      }
    });
    menuFahrzeug.setText("Fahrzeug");
    fahrzeugVermieten.setText("Vermieten");
    fahrzeugVermieten.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        fahrzeugVermieten_actionPerformed(e);
      }
    });
    fahrzeugZuruecknehmen.setText("Zurcknehmen");
    fahrzeugZuruecknehmen.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        fahrzeugZuruecknehmen_actionPerformed(e);
      }
    });
    menuAbrechnung.setText("Abrechnung");
    abrechnungPrivatKunde.setText("Privatkunde");
    abrechnungPrivatKunde.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        abrechnungPrivatKunde_actionPerformed(e);
      }
    });
    abrechnungFirmenKunde.setText("Firmenkunde");
    abrechnungFirmenKunde.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        abrechnungFirmenKunde_actionPerformed(e);
      }
    });
    HintergrundBild.setDebugGraphicsOptions(DebugGraphics.FLASH_OPTION);
    HintergrundBild.setLabelFor(this);
    menuFile.add(menuFileNeu);
    menuFile.add(menuFileExit);
    menuBar1.add(menuFile);
    menuBar1.add(menuFahrzeug);
    menuBar1.add(menuAbrechnung);
    menuFileNeu.add(neueFirmenKunde);
    menuFileNeu.add(neueReservierung);
    menuFahrzeug.add(fahrzeugVermieten);
    menuFahrzeug.add(fahrzeugZuruecknehmen);
    menuAbrechnung.add(abrechnungPrivatKunde);
    menuAbrechnung.add(abrechnungFirmenKunde);
    this.getContentPane().add(HintergrundBild, BorderLayout.CENTER);
    this.setJMenuBar(menuBar1);
  }

  //Aktion Datei | Beenden durchgefhrt
  public void fileExit_actionPerformed(ActionEvent e) {
    DVTAutoIO ioStream;
    ioStream = new DVTAutoIO();   

    //Beenden des Programms und Ausschreiben der Daten
    ioStream.datenBloeckeAusschreiben(Starter.fklFirmenKundenListe);
    ioStream.datenBloeckeAusschreiben(Starter.pklPrivatKundenListe);

    System.exit(0);
  }


  //berschreiben, damit das Programm bei Herunterfahren des Systems beendet werden kann
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  void neueFirmenKunde_actionPerformed(ActionEvent e) {
		try {
		    (new FirmenKundeEingabe()).setVisible(true);
		} 
		catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
  }

  void neueReservierung_actionPerformed(ActionEvent e) {
         new ReservierungsSystem();
  }

  void abrechnungPrivatKunde_actionPerformed(ActionEvent e) {
      (new MietendeGUI()).setVisible(true);
  }


  void fahrzeugVermieten_actionPerformed(ActionEvent e) {
    new KundenAngaben("none",null);
  }

  void fahrzeugZuruecknehmen_actionPerformed(ActionEvent e) {
		try {
		    (new FahrzeugAbgabeGUI()).setVisible(true);
		} 
		catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
  }

  void abrechnungFirmenKunde_actionPerformed(ActionEvent e) {
       (new MietendeGUI()).setVisible(true);
  }
}
 
