package fahrzeug;
import Gui.*;
import kunde.*;
import dvtautoio.*;
import java.util.Vector;


/**
 * Diese Klasse steuert die Erzeugung eines Angebotes
 *
 * @author Nathalie
 */
public class Kundenanfrage extends javax.swing.JFrame implements AngebotWeiterLeiten{

    //{{constructor

    public Kundenanfrage()
    {
     setSize(300,200);
     setVisible(false);
     //start den GUI um Klasse und Kategorie anzufragen
     (new AngebotStarter(this)).setVisible(true);
    }
/**
 */

    public Kundenanfrage(AngebotWeiterLeitenAnReservierung interfaceZurAngebotRueckgabe)
    {
     this();
     LnkZurReservierung = interfaceZurAngebotRueckgabe; //dieses wird benoetigt in zusammenarbeit mit AngebotWeiterLeiten
    }
    //}}



    //{{public methods
/**
 */

    public void fahrzeugKategorieKlasseEingabe(String kategorie, String klasse,boolean detailAngebot)
    {//wird nach Eingabe der Klasse und Kategorie aufgerufen
     this.setzeFahrzeuKategorie(kategorie, klasse);
     this.setzeKategorieText(kategorie);
     this.setzeKlasseText(klasse);
     //start den GUI zu Detailierte Eingabe oder Fahrzeuguebersicht
     //ueberpruefen der gewaehlte Button
     if(!detailAngebot)
      {//uebersicht von allen Fahrzeugen der gewuenschten Kategorie und Klasse
        if(fahrzeugeSuchen()==null)
           (new GeneralDialog(this,"gewnschte Fahrzeuge nicht verfgbar")).setVisible(true);
        else
           (new AlleFahrzeuge(fahrzeugeSuchen(),KategorieText,KlasseText)).setVisible(true);
      }
      else
      { //Formular zu detailiertem Angeboterzeuger
        (new AngebotFormular(this,this.holeKategorieText(),this.holeKlasseText())).setVisible(true);
      }
    }


    public void sonderWuenscheKatKlasse(String kategorie,String klasse)
    {
      this.setzeFahrzeuKategorie(kategorie, klasse);
      this.setzeKategorieText(kategorie);
      this.setzeKlasseText(klasse);
    }

    public void kundennummerEingabe(boolean firmenkundeja, int firmenkunde_nummer)
    { //wenn firmenkunde ausgewaehlt in der Formular dann den Nummer abspeichern fuer spaetere ueberpruefung
      if(firmenkundeja)
        {//firmenkunde
        setzeFirmenKunde(true);
        setzeFirmenkundenNummer(firmenkunde_nummer);
        firmenkundeUeberpruefen();
        if(isFirmenKunde())
         {
          ErzeugteAngebot=angebotAusgeben();
          if(ErzeugteAngebot != null)
             (new DetailAngebot(this,this.holeKategorieText(),this.holeKlasseText())).setVisible(true);
          else
             (new GeneralDialog(this,"kein passendes Fahrzeug gefunden")).setVisible(true);

         }
        }
      else
        {//privatkunde
         setzeFirmenKunde(false);
         setzeFirmenkundenNummer(0);
         ErzeugteAngebot=angebotAusgeben();
         if(ErzeugteAngebot != null)
            (new DetailAngebot(this,this.holeKategorieText(),this.holeKlasseText())).setVisible(true);
         else
            (new GeneralDialog(this,"kein passendes Fahrzeug gefunden")).setVisible(true);

        }
     }

    public void terminEingabe(int[] start, int[] ende)
    {//Jarh,Monate,Tage,Stunde
     setzeMietStart(start[0],start[1],start[2],start[3]);
     setzeMietEnde(ende[0],ende[1],ende[2],ende[3]);
     setzeMietDauer();
    }

    public void reset()
    {
     //neu anfangen, alle eintrage loeschen und den ersten frame (mit klasse und kategorie anfrage) wieder zeigen
    }

    public Vector fahrzeugeSuchen()
    {

      DVTAutoIO fahrzeugOeffner = new DVTAutoIO();
      //{{!!datenBloeckeEinlesen()

	  //08.2001 keine Auto Eigenschaften mehr in light version.
	  return ((FahrzeugBestand)fahrzeugOeffner.datenBloeckeEinlesen(fahrzeugKategorie)).eintraegeAuflisten(true);
    }

    public void firmenkundeUeberpruefen()
    {
     //firmenkundeliste oeffnen und firmenkundenummer benutzen um kunde zu finden
     DVTAutoIO kundenOeffner = new DVTAutoIO();
     FirmenKundenListe allFirmenkunde = (FirmenKundenListe)kundenOeffner.datenBloeckeEinlesen(new FirmenKundenListe());
     for(int i=0; i < allFirmenkunde.size(); i++)
     {
      if(((FirmenKunde)allFirmenkunde.elementAt(i)). holeFirmenKundenNummer() ==  holeFirmenkundenNummer())
        return; //firmenkunde gefunden, alles in ordnung
     }
     //firmenkunde nichtngefunden
     setzeFirmenKunde(false);
     setzeFirmenkundenNummer(0);
     (new GeneralDialog(this,"Firmenkunde ungltig")).setVisible(true);
     this.dispose();
    }

    public AngebotPreise berechnePreise(int wochenpreis)
    {//falls firmenkunde, rabatt mitberechnen
     int gesamtpreis;
     int tagespreis;
     int stundenpreis;

     if(isFirmenKunde())
      {
       tagespreis = (int)((float)0.8*wochenpreis/7)+1; //20% rabatt bei Firmenkunden
      }
     else
       {
        tagespreis = (int)((float)wochenpreis/7)+1;
       }

      gesamtpreis = (int)(holeMietDauer()* (float)tagespreis);
      stundenpreis = (int)((float)wochenpreis/(7*24))+1;
      return new AngebotPreise(tagespreis,stundenpreis,gesamtpreis);
    }

    public Angebote angebotAusgeben()
    {
     //fahrzeuge suchen, preise berechnen, AngebotPreis,MietpreisDesFahrzeugs und AngebotListe erzeugen
     //in den GUI zeigen
     Vector passendeFahrzeuge;
     passendeFahrzeuge= fahrzeugeSuchen();
     if(passendeFahrzeuge != null)
     {
      Angebote angebotFuerKunde = new Angebote(); //eine leere Angebotliste erzeugen
      for(int i=0; i < passendeFahrzeuge.size(); i++)
      {//Preis vorbereiten, MietpreisDesFahrzeugs bestehend aus Fahrzeug und Preis erstellen, in die Liste der Angebote eintragen
      AngebotPreise Preisdetail = berechnePreise(((Fahrzeug)passendeFahrzeuge.elementAt(i)).holeWochenpreis());
      angebotFuerKunde.addElement(new MietpreisDesFahrzeugs(Preisdetail,(Fahrzeug)passendeFahrzeuge.elementAt(i)));
      }
      return angebotFuerKunde;
     }
     else
       return null; //keine Fahrzeuge gefunden, die die Wuensche erfuellen

    }

    //}}

    //{{properties
    private Fahrzeug fahrzeugKategorie; //dieses property enthlt die gewuenschte Fahrzeugkategorie und Klasse
    private boolean firmenKunde= false;
    private int firmenkundenNummer;
    private float mietDauer;   //gibt die Anzahl der Miettagen , wird aus mietStart und mietEnde berechnet
    private Datum mietStart;
    private Datum mietEnde;
    private boolean sonderwuensche = false; //default: sonderwuensche irrellevant
    private Angebote ErzeugteAngebot=null; //dieses Variable haelt die Liste und uebergibt sie dem Reservierungssystem
    AngebotWeiterLeitenAnReservierung LnkZurReservierung;
    String KategorieText= new String();
    String KlasseText = new String();
   //}}

   //{{accessor methods

   public Fahrzeug holeFahrzeugKategorie()
   {
    return fahrzeugKategorie;
   }

   public void setzeFahrzeuKategorie(String kategorie, String klasse)
   {
    if(kategorie.equals("LKW"))
    {
     if(klasse.equals(">2.8"))
       {
         fahrzeugKategorie = new Ueber2_8Tonnen();
        }
     else
       {
         fahrzeugKategorie = new bis2_8Tonnen();
        }
    }
    else
      if(kategorie.equals("PickUp"))
        {
         fahrzeugKategorie = new PickUp();
         }
      else
        {//PKW
         if(klasse.equals("Kompaktwagen"))
         {
           fahrzeugKategorie = new KompaktKlasse();
          }
         else
           if(klasse.equals("Mittelklasse"))
           {
             fahrzeugKategorie = new MittelKlasse();
            }
           else
             if(klasse.equals("Oberklasse"))
             {
               fahrzeugKategorie = new OberKlasse();
             }
              else
               {//van
                fahrzeugKategorie = new Van();
               }
        }
   }

   public boolean isFirmenKunde()
   {
    return firmenKunde;
   }

   public void setzeFirmenKunde(boolean firmen_kunde)
   {
    firmenKunde = firmen_kunde;
   }

   public int holeFirmenkundenNummer()
   {
    return firmenkundenNummer;
   }

   public void setzeFirmenkundenNummer(int firmen_nummer)
   {
    firmenkundenNummer = firmen_nummer;
    }

   public Datum holeMietStart()
   {
    return mietStart;
   }

   public void setzeMietStart(int jahr, int monat, int tag, int stunde)
   {
     mietStart = new Datum(jahr,monat,tag,stunde);
   }

   public Datum holeMietEnde()
   {
    return mietEnde;
   }

   public void setzeMietEnde(int jahr, int monat, int tag, int stunde)
   {
     mietEnde = new Datum(jahr,monat,tag,stunde);

   }

   public void setzeMietDauer()
   {
    float start= mietStart.anzahlTageAusgeben();
    float end = mietEnde.anzahlTageAusgeben();
    mietDauer = end-start;
    }

   public float holeMietDauer()
   { //in Tage
    return mietDauer;
   }


   public boolean isSonderwuensche()
   {
    return sonderwuensche;
    }

   public void setzeSonderwuensche(boolean sonder_active)
   {
    sonderwuensche = sonder_active;
    }

   public void setzeErzeugteAngebot(Angebote angebot)
   {
    ErzeugteAngebot = angebot;
   }

   public Angebote holeErzeugteAngebot()
   {
    return ErzeugteAngebot;
    }

   public String holeKategorieText()
   {
    return KategorieText;
    }

   public void setzeKategorieText(String kat)
   {
    KategorieText = kat;
   }

   public String holeKlasseText()
   {
    return KlasseText;
   }

   public void setzeKlasseText(String kls)
   {
    KlasseText= kls;
    }
   //}}

  //{{implement AngebotWeiterLeiten-Interface, Interface wird von GUI benutzt um von Angebot in die Reservierung zu bewegen
  public void angebotUebergabe()
  {
    LnkZurReservierung.angebotUebergabeAnReservierung();
  }
  //}}

}
