/* KundenAngaben bei der Mietvertragvorbereitung */

package fahrzeug;


import dvtautoio.*;
import Gui.*;
import kunde.*;
import java.util.GregorianCalendar;
import java.util.Date;
import java.util.Calendar;
import java.io.*;
/**
 * Diese Klasse verarbeitet die Erstellung von Mietvertrge
 *
 * @author Nathalie
 */

public class KundenAngaben extends javax.swing.JFrame{

    public KundenAngaben()
    {
      setSize(200,100);
      setVisible(false);
      //serialisierte Reservierungen oeffnen
      DVTAutoIO ListenOeffner = new DVTAutoIO();
      VorhandeneReservierungen = (Reservierungen) ListenOeffner.datenBloeckeEinlesen(new Reservierungen());

      //serialisierte LaufendeVertraege oeffnen

      VorhandeneMietvertraege = (LaufendeVertraege) ListenOeffner.datenBloeckeEinlesen(new LaufendeVertraege());

     }

    public KundenAngaben(String reservierung_nummer,ReservierungsSystem rsr)
    {
      this();
      if(rsr != null)
       {
        zuReservierung = rsr;
        }
      if(reservierung_nummer.equals("none"))
         (new MietvertragGui(this)).setVisible(true);
      else
         {
          String tmpKundenName = ueberpruefeReservierung(reservierung_nummer);
          String[] nummerUndStand = fahrzeugNummerStandortZeigen();
          //MietvertragGUI mit gesetztem Reservierungsnummerfeld,name,nummer und standort. warte auf Fuehrerscheineingabe
         (new MietvertragGui(this,reservierung_nummer,tmpKundenName,nummerUndStand[0],nummerUndStand[1])).setVisible(true);
         }
    }

    //{{public methods
    public String[] fahrzeugNummerStandortZeigen()
    {
      //wird aufgerufen wenn Kundennamen bestaetigt ist
      String[] tmpNummerStandort = new String[2];
      Fahrzeug tmpFahrzeug = (KundenReservierung.holeFahrzeugInfo()).holeLnkFahrzeug();
      tmpNummerStandort[0] = String.valueOf(tmpFahrzeug.holeNummernschild()); //Nummernschild
      tmpNummerStandort[1]= tmpFahrzeug.holeStandort(); //Standort des Fahrzeuges
      return tmpNummerStandort;
    }

    public String ueberpruefeReservierung(String reservierungsnummer)
    {
     KundenReservierung= VorhandeneReservierungen.eintraegeAuflisten(reservierungsnummer);
     //Position in der Reservierungen festhalten, wird gebraucht wenn das Mietstartdatum veraendert werden soll
     ReservierungPositionInListe= VorhandeneReservierungen.indexOf(KundenReservierung);
     if(KundenReservierung != null)
     {
       if(KundenReservierung.isGemietet())
       {//das Auto wurde schon gemietet, Reservierung nicht mehr gueltig
        return null;
       }
       else
       {
       String tmpkundenName = KundenReservierung.holeKundenName();
       //zeige Kundenname in GUI und warte auf Bestaetigung zum Weitermachen
       return tmpkundenName;
       }
     }
     else
     {
       //Resevierung nicht vorhanden zeige Dialogbox nicht gefunden
       return null;
     }

    }

    public String fuehrerscheinNummerEingabe(boolean fuehrerschein)
    { //gibt den Mietvertragsnummer als Rueckgabewert
      //wenn Fuehrerschein in Ordnung, produziere den Mietvertrag, druck aus, fuegt den
      //Mietvertrag in die Mietvertragliste. Mietdatum in der Reservierungen updaten
     if(fuehrerschein)
     {
      //heutige Datum als Mietstartdatum setzen
      GregorianCalendar heuteDatum = (GregorianCalendar)Calendar.getInstance();
      aktuelMietStart = new Datum(heuteDatum.get(Calendar.YEAR),heuteDatum.get(Calendar.MONTH), heuteDatum.get(Calendar.DAY_OF_MONTH), heuteDatum.get(Calendar.HOUR_OF_DAY));
      //Vertragsnummer erzeugen
      tmpVertragNummer = KundenReservierung.holeReservierungsnummer();
      String mietDatumString = (String.valueOf(heuteDatum.get(Calendar.YEAR))).substring(2)+ String.valueOf(heuteDatum.get(Calendar.MONTH))+ String.valueOf(heuteDatum.get(Calendar.DAY_OF_MONTH))+ String.valueOf(heuteDatum.get(Calendar.HOUR_OF_DAY));
      tmpVertragNummer += mietDatumString;
      //neue Mietvertrag erzeugen
      mietvertragErzeugen();
      VorhandeneMietvertraege.neuerEintrag(KundenMietvertrag);

      MietTermin tmpTermin = KundenReservierung.holeLnkMietTermin();
       //mietdauer berechnen
      int mietDauerTage = (int)(tmpTermin.holeRueckgabeDatum().anzahlTageAusgeben()-tmpTermin.holeStartDatum().anzahlTageAusgeben());

      //Mietstartdatum in der Reservierung korigieren
      tmpTermin.setzeStartDatum(aktuelMietStart);
      //MietendeDatum korrigieren
      heuteDatum.add(Calendar.DAY_OF_YEAR, mietDauerTage); //erzeuge das aktuelle mietendedatum
      Datum tmpEndeDatum = new Datum(heuteDatum.get(Calendar.YEAR),heuteDatum.get(Calendar.MONTH), heuteDatum.get(Calendar.DAY_OF_MONTH), heuteDatum.get(Calendar.HOUR_OF_DAY));
      tmpTermin.setzeRueckgabeDatum(tmpEndeDatum);
      KundenReservierung.setzeLnkMietTermin(tmpTermin);


      //Reservierung sperren, auto gemietet
      KundenReservierung.setzeGemietet(true);
      //Reservierungeintrag in der Liste wird erneuert
      VorhandeneReservierungen.setElementAt(KundenReservierung,ReservierungPositionInListe);
      //{{Reservierungen und Mietvertragliste serialisieren und speichern
      //{{code here
      DVTAutoIO tmpSchreiber = new DVTAutoIO();
      tmpSchreiber.datenBloeckeAusschreiben(VorhandeneMietvertraege);
      tmpSchreiber.datenBloeckeAusschreiben(VorhandeneReservierungen);
      //}}
      return tmpVertragNummer;
     }
     else
     {
      return null;
      }
    }

    public void reservierungLoeschen()
    {
      //Fahrzeug wieder freigeben
      DVTAutoIO fahrzeugOeffner = new DVTAutoIO();
      Fahrzeug tmpSelectedAuto = KundenReservierung.holeFahrzeugInfo().holeLnkFahrzeug();
      tmpSelectedAuto.setzeVerfuegbar(true);
      System.out.println("Auto zum freigeben"+ tmpSelectedAuto.getClass().getName());
      FahrzeugBestand tmpListe = (FahrzeugBestand)fahrzeugOeffner.datenBloeckeEinlesen(tmpSelectedAuto);
      tmpListe.FahrzeugLoeschen(tmpSelectedAuto.holeNummernschild());
      tmpListe.neuerEintrag(tmpSelectedAuto);
      String tmpName = tmpSelectedAuto.getClass().getName();
      tmpName = tmpName.substring(tmpName.indexOf('.')+1);
      fahrzeugOeffner.datenBloeckeAusschreiben(tmpListe,tmpName);
      //}}


      //Fuehreschein nicht gueltigt, breche ab, loesche den Reservierung, exit
      VorhandeneReservierungen.removeElementAt(ReservierungPositionInListe);
      //{{serialisere und speichere die Reservierungen
      //{{code here
      DVTAutoIO tmpSchreiber = new DVTAutoIO();
      tmpSchreiber.datenBloeckeAusschreiben(VorhandeneReservierungen);
      //}}
      //{{Reservierungscounter um 1 decrementieren
      String ReservierungsnummerCounter= new String();
      try{
       java.io.ObjectInputStream i = new java.io.ObjectInputStream(new FileInputStream("rcounter.out"));
       ReservierungsnummerCounter = (String)i.readObject();
       }
       catch(java.io.IOException iofehler){}
       catch(java.lang.ClassNotFoundException cnot){}

       ReservierungsnummerCounter = String.valueOf((Integer.parseInt(ReservierungsnummerCounter))-1);
       try{
        java.io.ObjectOutputStream o = new java.io.ObjectOutputStream(new FileOutputStream("rcounter.out"));
        o.writeObject(ReservierungsnummerCounter);
        o.close();}
        catch(java.io.IOException ioweg){}
      //}}

    }

    public void mietvertragErzeugen()
    {
     KundenMietvertrag = new Mietvertrag(KundenReservierung.holeKundenName(),
                                        tmpVertragNummer,
                                        true,
                                        aktuelMietStart,
                                        ((KundenReservierung.holeFahrzeugInfo()).holeLnkFahrzeug()).holeNummernschild(),
                                        ((KundenReservierung.holeFahrzeugInfo()).holeLnkFahrzeug()).holeStandort(),
                                        ((KundenReservierung.holeFahrzeugInfo()).holeLnkFahrzeug()).holeKilometerstand(),
                                        KundenReservierung.IsIstFirmenKunde(),
                                        KundenReservierung.holeFirmenkundenNummer(),
                                        KundenReservierung.holeFahrerName(),
                                        KundenReservierung.holeFahrzeugInfo().holeLnkFahrzeug().getClass().getName()
                                        );

    }

    public void killMietSystem()
    {
     if(zuReservierung != null)
      {
       zuReservierung.killReservierung();
      }
     else
      {
       dispose();
      }
    }

    //}}

        //{{***************MAIN*********************

    static public void main(String args[])
    {
     try{
        new KundenAngaben();
     }
		catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}

    }
    //}}****************************************


    /*#Reservierungen lnkReservierung;*/
    private boolean FuehrerscheinVorhanden;
    private Reservierungen VorhandeneReservierungen;
    private Reservierung KundenReservierung= null;
    private Mietvertrag KundenMietvertrag;
    private LaufendeVertraege VorhandeneMietvertraege;
    int ReservierungPositionInListe=0;
    String tmpVertragNummer= new String();
    boolean kommtVonReservierung = false;
    Datum aktuelMietStart;
    ReservierungsSystem zuReservierung=null;

    //accessor
    public Mietvertrag holeKundenMietvertrag()
    {
     return KundenMietvertrag;
    }

    public Reservierung gibtReservierungZurAusgabe()
    {
     return KundenReservierung;
    }
}
